﻿from PIL import Image
from PIL import ImageDraw


TabA=['0001101', '0011001', '0010011', '0111101', '0100011', '0110001', '0101111', '0111011', '0110111', '0001011']
TabB=['0100111', '0110011', '0011011', '0100001', '0011101', '0111001', '0000101', '0010001', '0001001', '0010111']
TabC=['1110010', '1100110', '1101100', '1000010', '1011100', '1001110', '1010000', '1000100', '1001000', '1110100']
chif1=['AAAAAA','AABABB','AABBAB','AABBBA','ABAABB','ABBAAB','ABBBAA','ABABAB','ABABBA','ABBABA']
test12="978236658406"
test13="9782366584066"

def verif(ean,l):
    if len(ean)==l:
        return(True)
    else :
        return(False)

def calculclef(ean):
    clef=0
    for i in range(12):
        if(i%2==0):
            clef=clef+int(ean[i])
        else:
            clef=clef+int(ean[i])*3
    if(clef%10==0):
        clef=0
    else :
        clef=10-clef%10
    return(clef)

def chiffrage(ean13):
    bord="101"
    separateur="01010"
    module=bord
    for i in range(13):
        if i==0:
            ref=int(ean13[i])
        elif i<7:
            if chif1[ref][i-1]=='A':
                module=module+TabA[int(ean13[i])]
            else:
                module=module+TabB[int(ean13[i])]
            if i==6:
                module=module+separateur
        else:
            module=module+TabC[int(ean13[i])]
    module=module+bord
    return(module)

def trace(module):
    HAUTEUR= 240
    LARGEUR  = 95*4
    LARGEUR_BARRE = 4
    im = Image.new("RGB",(LARGEUR,HAUTEUR ),"white")
    draw = ImageDraw.Draw(im)
    i=0
    for chiffre in module:
        lg=200
        if i<3 or i>91 or (i>44 and i<50): lg=240
        if chiffre == "1":
            draw.rectangle(((LARGEUR_BARRE *i,0),(LARGEUR_BARRE+LARGEUR_BARRE*i-1,lg)),fill="black",)
        elif chiffre == "0":
            draw.rectangle(((LARGEUR_BARRE *i,0),(LARGEUR_BARRE+LARGEUR_BARRE*i-1,lg)),fill="white",)
        i=i+1
    im.show()


def lance():
    ean=""
    while(not verif(ean,12)):
        ean=input('Saisir')
    nean=int(ean)
    ean13=ean+str(calculclef(ean))
    print(ean13)
    md13=chiffrage(ean13)
    print(md13)
    trace(md13)

def lance13():
    cl="i"
    c13="O"
    while cl!=c13:
        ean=""
        while(not verif(ean,13)):
            ean=input('Saisir')
        nean=int(ean[1:12])
        c13=ean[12]
        cl=str(calculclef(ean))
        ean13=ean+cl
    print(ean13)
    md13=chiffrage(ean13)
    print(md13)
    trace(md13)

